/************************************************************************/
/*  Copyright (C), 2016-2020, [IT], Ȩ;
/*  ģ  ;
/*      ;
/*
/*      [V];	
/*      ߣ[IT];
/*      ڣ[12/19/2016];
/*
/*
/*  ע    ⣺;
/*
/*  ޸ļ¼[IT];
/*  ޸ڣ;
/*  ޸İ汾;
/*  ޸ݣ;
/************************************************************************/
#ifndef __ENCODING_CONVERSION__
#define __ENCODING_CONVERSION__

#include <string>
#include <vector>
using namespace std;

#ifndef _UNICODE
typedef string TString;
#else
typedef wstring TString;
#endif

#pragma once

namespace EncodingConverion
{
	// ַתΪӦASCIIʮֵ;
	extern char CharToInt(char ch);
	// ַתʮֵ;
	extern char StrToBin(IN char (&str)[2]);
	extern void GB2312ToUTF_8(string& pOut, const char *pText, int pLen);
	// ASCIIַתUNICODEַ;
	extern WCHAR* ASCII2UNICODE(IN LPCCH lpASCIIStr);
	extern BOOL   ASCII2UNICODE(IN LPCCH lpASCIIStr, OUT PWCH pUNICODEStr, IN CONST INT& nUNICODEStrLen);
	extern BOOL   ASCII2UNICODE(IN LPCCH lpASCIIStr, OUT wstring &strResult);

	// UNICODEַתASCIIַ;
	extern CHAR* UNICODE2ASCII(IN LPWCH lpUNICODEStr);
	extern BOOL  UNICODE2ASCII(IN LPWCH lpUNICODEStr, OUT LPCH pASCIIStr, IN CONST INT& nASCIIStrLen);
	extern BOOL  UNICODE2ASCII(IN LPWCH lpUNICODEStr, OUT string &strResult);

	// UNICODEַתUFT8ַ;
	extern CHAR* UNICODE2UTF8(IN LPWCH lpUNICODEStr);
	extern BOOL  UNICODE2UTF8(IN LPWCH lpUNICODEStr, OUT LPCH pUTF8Str, IN CONST INT& nUTF8StrLen);
	extern BOOL  UNICODE2UTF8(IN LPWCH lpUNICODEStr, OUT string &strResult);

	// ASCIIַתUTF8ַ;
	extern CHAR* ASCII2UTF8(IN LPCCH lpASCIIStr);
	extern BOOL  ASCII2UTF8(IN LPCCH lpASCIIStr, OUT LPCH pUTF8Str, IN CONST INT& nUTF8StrLen);
	extern BOOL  ASCII2UTF8(IN LPCCH lpASCIIStr, OUT string &strResult);

	// UTF-8ַתUNICODEַ;
	extern WCHAR* UTF82UNICODE(IN LPCCH lpUTF8);
	extern BOOL   UTF82UNICODE(IN LPCCH lpUTF8, OUT PWCH pUNICODEStr, IN CONST INT& nUNICODEStrLen);
	extern BOOL   UTF82UNICODE(IN LPCCH lpUTF8, OUT wstring &strResult);

	// UTF-8ַתASCIIַ;
	extern CHAR*  UTF82ASCII(IN LPCCH lpUTF8);
	extern BOOL   UTF82ASCII(IN LPCCH lpUTF8, OUT LPCH pASCIIStr, IN CONST INT& nASCIIStrLen);
	extern BOOL   UTF82ASCII(IN LPCCH lpUTF8, OUT string &strResult);

	// UTF-8GB2312;
	extern string UTF8IntoGB2313(IN CHAR* pUTF8Text, IN const INT& nUTF8TextLen);
	// GB2312UTF-8;
	extern string GB2312IntoUTF8(IN CHAR* pGB2312Text, IN const INT& nGB2312TextLen);

	// ַΪGB2312ʽURL;
	extern string EnCode_GB2312URL(IN CHAR* pText);
	extern void EnCode_GB2312URL(IN CHAR* pText, OUT string& strResult);
	// ַΪUTF-8ʽURL;
	extern string EnCode_UTF8URL(IN const CHAR* pText);
	extern void EnCode_UTF8URL(IN const CHAR* pText, OUT string& strResult);
	// ַΪUNICODEʽURL;
	extern string EnCode_UNICODEURL(IN const CHAR* pText);	// δɸú;

	// UTF-8ʽURL;
	extern string DeCode_URLUTF8(IN const CHAR* pURLText);
	extern void DeCode_URLUTF8(IN const CHAR* pURLText, OUT string& strResult);
	// GB2312ʽURL;
	extern string DeCode_URLGB2312(IN const CHAR* pURLText);
	extern void DeCode_URLGB2312(IN const CHAR* pURLText, OUT string& strResult);
	// UNICODEʽURL;
	extern string DeCode_URLUNICODE(IN const CHAR* pURLText);
	extern void DeCode_URLUNICODE(IN const CHAR* pURLText, OUT string& strResult);
};

#endif